//-----------------------------------------------------------------------------
/// Modulename : BinarizeDlg.cpp @file
///
/// Interface  : BinarizeDlg.h
///
///              Implementation of class CBinarizeDlg.
///
///  2003 Sirona Dental Systems GmbH - All Rights Reserved
///
/// Status     : Draft
///
/// Security   : -
///
/// Revision history - Version 1.0
///
/// 15.09.03 - Draft => V.1.0 (MCI, Fa. MGW)
/// 23.10.03 - Added about box (MCI, Fa. MGW)
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Standard includes
//-----------------------------------------------------------------------------
#include "stdafx.h"

//-----------------------------------------------------------------------------
// Own includes
//-----------------------------------------------------------------------------
#include "BinarizeDlg.h"
#include "AboutDlg.h"

//-----------------------------------------------------------------------------
// Private definitions, -macros and -constants
//-----------------------------------------------------------------------------
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//-----------------------------------------------------------------------------
// Private data types
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// External references
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Module global variables
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Prototype of the private functions
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Implementation
//-----------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CBinarizeDlg, CDialog)
   //{{AFX_MSG_MAP(CBinarizeDlg)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//-----------------------------------------------------------------------------
/// Constructor
///
/// @param pParent [IN] dialog parent
///
/// Remarks  : -
///
/// Security : -
///
/// Status   : Draft
///
/// Revision history - Version 1.0
///
/// 15.09.03 - Draft => V.1.0 (MCI, Fa. MGW)
//-----------------------------------------------------------------------------
CBinarizeDlg::CBinarizeDlg( CWnd* pParent ) : CDialog(CBinarizeDlg::IDD, pParent)
{
   //{{AFX_DATA_INIT(CBinarizeDlg)
   m_uiThreshold = 127;
   //}}AFX_DATA_INIT
}

//-----------------------------------------------------------------------------
/// Dialog data exchange
///
/// @param pDX [IN] MFC standard
///
/// Remarks  : -
///
/// Security : -
///
/// Status   : Draft
///
/// Revision history - Version 1.0
///
/// 15.09.03 - Draft => V.1.0 (MCI, Fa. MGW)
//-----------------------------------------------------------------------------
void CBinarizeDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CBinarizeDlg)
   DDX_Control(pDX, IDC_PARAMETER1_SPIN, m_spinThreshold);
   DDX_Text(pDX, IDC_PARAMETER1, m_uiThreshold);
   //}}AFX_DATA_MAP
}

//-----------------------------------------------------------------------------
/// Dialog initialization
///
/// @return MFC standard
///
/// Remarks  : -
///
/// Security : -
///
/// Status   : Draft
///
/// Revision history - Version 1.0
///
/// 15.09.03 - Draft => V.1.0 (MCI, Fa. MGW)
//-----------------------------------------------------------------------------
BOOL CBinarizeDlg::OnInitDialog() 
{
   CDialog::OnInitDialog();
   
   m_spinThreshold.SetRange( 0, 255 );
   m_spinThreshold.SetPos( m_uiThreshold );
   
   return TRUE;
}

//-----------------------------------------------------------------------------
/// Gets the data
///
/// Remarks  : -
///
/// Security : -
///
/// Status   : Draft
///
/// Revision history - Version 1.0
///
/// 15.09.03 - Draft => V.1.0 (MCI, Fa. MGW)
//-----------------------------------------------------------------------------
void CBinarizeDlg::OnOK() 
{
   if (!UpdateData( TRUE ))
      return;
   
   CDialog::OnOK();
}

//-----------------------------------------------------------------------------
/// Displays informations about the plug-in
///
/// Remarks  : -
///
/// Security : -
///
/// Status   : Draft
///
/// Revision history - Version 1.0
///
/// 23.10.03 - Draft => V.1.0 (MCI, Fa. MGW)
//-----------------------------------------------------------------------------
void CBinarizeDlg::OnAbout() 
{
   CAboutDlg dlg;
   (void) dlg.DoModal();
}
