//-----------------------------------------------------------------------------
/// Headername  : BinarizeView.h @file
///
///               Interface of class CBinarizeView.
///
///  2003 Sirona Dental Systems GmbH - All Rights Reserved
///
/// Status      : Draft
///
/// Revision history - Version 1.0
///
/// 15.09.03 - Draft => V.1.0 (MCI, Fa. MGW)
//-----------------------------------------------------------------------------
#ifndef BINARIZEVIEW_H__
#define BINARIZEVIEW_H__

//-----------------------------------------------------------------------------
// Standard includes
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Own includes
//-----------------------------------------------------------------------------
#include "ISidexisNG.h"
#include "customimage.h"

//-----------------------------------------------------------------------------
// Definitions, macros und constants
//-----------------------------------------------------------------------------
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//-----------------------------------------------------------------------------
// Data types
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Prototype of the public functions
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
/// Classname  : CBinarizeView : public CView
///
/// View class
//-----------------------------------------------------------------------------
class CBinarizeView : public CView
{
   //---------------------------------------------------------------------------
   // Member functions
   //---------------------------------------------------------------------------
protected: // create from serialization only
   DECLARE_DYNCREATE(CBinarizeView)
   CBinarizeView();
public:
   virtual ~CBinarizeView();

public:
   CBinarizeDoc* GetDocument() { return (CBinarizeDoc*)m_pDocument; }

   //{{AFX_VIRTUAL(CBinarizeView)
	public:
   virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

protected:
   LPDISPATCH GetApplication();

   //{{AFX_MSG(CBinarizeView)
   afx_msg void OnGetactiveimage();
   afx_msg void OnFilter();
   afx_msg void OnSetactiveimage();
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()

   //---------------------------------------------------------------------------
   // Member variables                                       - Short description
   //---------------------------------------------------------------------------
protected:
   LPDISPATCH     m_pdispApp;
   IApplication   m_SidexisXG;
   CCustomImage   m_Image;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // BINARIZEVIEW_H__
