#include "stdafx.h"
#include "objectmodel.h"
#include "MyCoolExeStartPlugin.h"

#include "isidexisng.h"  // XG object model
#include "DirectDentalEnums.h"
#include "PluginDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CMyCoolExeStartPlugin, CCmdTarget)

BEGIN_MESSAGE_MAP(CMyCoolExeStartPlugin, CCmdTarget)
   //{{AFX_MSG_MAP(CMyCoolExeStartPlugin)
      // NOTE - the ClassWizard will add and remove mapping macros here.
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CMyCoolExeStartPlugin, CCmdTarget)
   //{{AFX_DISPATCH_MAP(CMyCoolExeStartPlugin)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "LastParameters", GetLastParameters, SetLastParameters, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "Vendor", GetVendor, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "Description", GetDescription, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "Version", GetVersion, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "Category", GetCategory, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "MenuEntry", GetMenuEntry, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "MessageString", GetMessageString, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "TooltipText", GetTooltipText, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "FriendlyName", GetFriendlyName, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "BitmapResourceSmall", GetBitmapResourceSmall, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "BitmapResourceLarge", GetBitmapResourceLarge, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "Key", GetKey, SetNotSupported, VT_BSTR)
   DISP_PROPERTY_EX(CMyCoolExeStartPlugin, "Reserved", GetReserved, SetNotSupported, VT_BSTR)
   DISP_FUNCTION(CMyCoolExeStartPlugin, "Run", Run, VT_ERROR, VTS_NONE)
   //}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IMyCoolExeStartPlugin to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {F6833B14-AE9A-497D-8DE1-96624C66BF62}
static const IID IID_IMyCoolExeStartPlugin =
{ 0xf6833b14, 0xae9a, 0x497d, { 0x8d, 0xe1, 0x96, 0x62, 0x4c, 0x66, 0xbf, 0x62 } };

BEGIN_INTERFACE_MAP(CMyCoolExeStartPlugin, CCmdTarget)
   INTERFACE_PART(CMyCoolExeStartPlugin, IID_IMyCoolExeStartPlugin, Dispatch)
END_INTERFACE_MAP()

// {BF78D0F2-41A2-4BF8-931C-9F3CB656194C}
IMPLEMENT_OLECREATE_EX(CMyCoolExeStartPlugin, "ObjectModel.MyCoolExeStartPlugin", 0xbf78d0f2, 0x41a2, 0x4bf8, 0x93, 0x1c, 0x9f, 0x3c, 0xb6, 0x56, 0x19, 0x4c)

CMyCoolExeStartPlugin::CMyCoolExeStartPlugin()
{
   EnableAutomation();
   AfxOleLockApp();
}

CMyCoolExeStartPlugin::~CMyCoolExeStartPlugin()
{
   AfxOleUnlockApp();
}


void CMyCoolExeStartPlugin::OnFinalRelease()
{
   // When the last reference for an automation object is released
   // OnFinalRelease is called.  The base class will automatically
   // deletes the object.  Add additional cleanup required for your
   // object before calling the base class.

   CCmdTarget::OnFinalRelease();
}

BOOL CMyCoolExeStartPlugin::CMyCoolExeStartPluginFactory::UpdateRegistry( BOOL bRegister )
{
   if (bRegister)
      return AfxOleRegisterServerClass( m_clsid, m_lpszProgID, m_lpszProgID, m_lpszProgID, OAT_DISPATCH_OBJECT );
   else
      return AfxOleUnregisterClass( m_clsid, m_lpszProgID );
}

LPDISPATCH CMyCoolExeStartPlugin::GetApplication()
{
   // Retrieve ClassID
   CLSID   clsid;
   HRESULT hr = CLSIDFromProgID( L"SIDEXISNG.Application", &clsid );
   
   if (FAILED( hr ))
      return NULL;

   // Find the active object
   LPUNKNOWN pUnkSrv = NULL;

   hr = GetActiveObject( clsid, NULL, &pUnkSrv );  // returns Unknown pointer
   if (FAILED( hr ))
      return NULL;

   // Get the Dispatch interface
   LPDISPATCH pdispApp = NULL;

   hr = pUnkSrv->QueryInterface( IID_IDispatch, (void**) &pdispApp );   // returns the dispatch Interface

   if (FAILED( hr ))
   {
      (void) pUnkSrv->Release();
      return NULL;
   }
   // We don't need this anymore
   (void) pUnkSrv->Release();

   return pdispApp;
}

BOOL CMyCoolExeStartPlugin::GetApplicationVersion( CString& strVersion, int& nVersionMajor, int& nVersionMinor )
{
   // Initialization
   strVersion.Empty();
   nVersionMajor = 0;
   nVersionMinor = 0;

   // Get the version
   IApplication Application;

   Application.AttachDispatch( GetApplication() );

   strVersion = Application.GetVersion();

   int nPos = strVersion.Find( _T(".") );

   if (nPos == -1)
      return FALSE;

   nVersionMajor = _ttoi( strVersion.Left( nPos ) );
   nVersionMinor = _ttoi( strVersion.Right( strVersion.GetLength() - nPos - 1 ) );

   return TRUE;
}

BSTR CMyCoolExeStartPlugin::GetReserved() 
{
   CString strResult;

   // Reserved, must be empty
   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetLastParameters() 
{
   CString strResult;
   return strResult.AllocSysString();
}

void CMyCoolExeStartPlugin::SetLastParameters( LPCTSTR lpszNewValue )
{
   UNREFERENCED_PARAMETER( lpszNewValue );
}

BSTR CMyCoolExeStartPlugin::GetVendor() 
{
   CString strResult;
   (void) strResult.LoadString( IDS_COMPANY );
   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetDescription() 
{
   CString strResult;
   (void) strResult.LoadString( IDS_DESCRIPTION );
   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetVersion() 
{
   CString strResult;

   (void) strResult.LoadString( IDS_VERSION );
   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetCategory() 
{
   CString strResult = CATEGORY_VOID;

   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetMenuEntry() 
{
   CString strResult;
   (void) strResult.LoadString( IDS_MENUENTRY );
   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetMessageString() 
{
   CString strResult;
   (void) strResult.LoadString( IDS_STATUSBAR );
   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetTooltipText() 
{
   CString strResult;
   (void) strResult.LoadString( IDS_TOOLTIP );
   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetFriendlyName() 
{
   CString strResult;
   (void) strResult.LoadString( IDS_FRIENDLYNAME );
   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetBitmapResourceSmall() 
{
   CString strVersion;
   int     nVersionMajor, nVersionMinor;
   CString strResult;

   if (GetApplicationVersion( strVersion, nVersionMajor, nVersionMinor ))
   {
      if ((nVersionMajor == 1) && (nVersionMinor < 3))   // version < 1.3?
         strResult = _T("IDB_SMALL");
      else
         strResult = _T("idb_small.bmp");
   }
   else
      strResult = _T("idb_small.bmp");
   
   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetBitmapResourceLarge() 
{
   CString strVersion;
   int     nVersionMajor, nVersionMinor;
   CString strResult;

   if (GetApplicationVersion( strVersion, nVersionMajor, nVersionMinor ))
   {
      if (nVersionMajor == 1 && nVersionMinor < 3)
         strResult = _T("IDB_LARGE");
      else
         strResult = _T("idb_large.bmp");
   }
   else
      strResult = _T("idb_large.bmp");

   return strResult.AllocSysString();
}

BSTR CMyCoolExeStartPlugin::GetKey() 
{
   CString strResult;

   // Reserved, must be empty
   return strResult.AllocSysString();
}

SCODE CMyCoolExeStartPlugin::Run()
{
   IApplication  Application;
   CPluginDialog dlg;
   CString       strStatusMsgWorking;
   CString       strStatusMsgReady;

   (void) strStatusMsgWorking.LoadString( IDS_WORKING );
   (void) strStatusMsgReady.LoadString( IDS_READY );

   Application.AttachDispatch( GetApplication() );

   Application.SetStatusBar( strStatusMsgWorking );

   (void) dlg.DoModal();

   Application.SetStatusBar( strStatusMsgReady );

   return S_OK;
}
