//-----------------------------------------------------------------------------
/// Headername  : NGObjTypes.h @file
///
///               SIDEXIS NG Programming Model object types definitions
///
///  2003 Sirona Dental Systems GmbH - All Rights Reserved
///
/// Status      : Released
///
/// Change history - Version 1.1
///
/// 26.11.02 - Draft => V.1.0 (MCI, Fa. MGW)
/// 19.01.03 - Review + Release V.1.0 (JueZi, GBE)
/// 14.03.03 - Added Polyline, Rect, Ellipse, Symbol => V.1.1 (MCI, Fa. MGW)
/// 14.03.03 - Renamed NGMeasure => NGLength, NGTextbox => NGText (MCI, Fa. MGW)
/// 15.03.03 - Review + Release V.1.1 (JueZi, GBE)
//-----------------------------------------------------------------------------
#ifndef __NGOBJTYPES_H
#define __NGOBJTYPES_H

//-----------------------------------------------------------------------------
// Definitions, macros, constants
//-----------------------------------------------------------------------------
#if _MSC_VER > 1000 // VC++ Version > 4.0
#pragma once // open only once during build
#endif // _MSC_VER > 1000

//-----------------------------------------------------------------------------
// Data types
//-----------------------------------------------------------------------------
typedef enum
{
   NGNone        = -1,
   NGUnknown     =  0,
   NGTake        =  1,
   NGDiagnosis   =  2,
   NGArrow       =  3,
   NGRoi         =  4,
   NGLength      =  5,
   NGText        =  6,
   NGAngle       =  7,
   NGCut         =  8,
   NGImage       =  9,
   NGExam        = 10,
   NGPolyline    = 11,
   NGRect        = 12,
   NGEllipse     = 13,
   NGSymbol      = 14
} NGObjectTypes;

typedef enum
{
   NGPixel      = 1,
   NGMicrometer = 2,
   NGDegree     = 3,
   NGPercent    = 4
}  NGMeasureUnits;

#endif //__NGOBJTYPES_H
