#ifndef PLUGINDIALOG_H__
#define PLUGINDIALOG_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPluginDialog : public CDialog
{
public:
   CPluginDialog(CWnd* pParent = NULL);

   LPDISPATCH GetApplication();

   //{{AFX_DATA(CPluginDialog)
   enum { IDD = IDD_PLUGIN_DIALOG };
   CTreeCtrl   m_ctlObjectModel;
   //}}AFX_DATA

   //{{AFX_VIRTUAL(CPluginDialog)
   protected:
   virtual void DoDataExchange(CDataExchange* pDX);
   //}}AFX_VIRTUAL

protected:
   void     UpdateModel();

   void     DumpSelectionObjects( LPDISPATCH pdispSelectionObjects, HTREEITEM htParent );
   void     DumpObjects(          LPDISPATCH pdispObjects,          HTREEITEM htParent );
   void     DumpObject(           LPDISPATCH pdispObject,           HTREEITEM htParent );
   void     DumpDiagnoses(        LPDISPATCH pdispDiagnoses,        HTREEITEM htParent );
   void     DumpDiagnosis(        LPDISPATCH pdispDiagnosis,        HTREEITEM htParent );
   void     DumpAngles(           LPDISPATCH pdispAngles,           HTREEITEM htParent );
   void     DumpAngle(            LPDISPATCH pdispAngle,            HTREEITEM htParent );
   void     DumpCuts(             LPDISPATCH pdispCuts,             HTREEITEM htParent );
   void     DumpCut(              LPDISPATCH pdispCut,              HTREEITEM htParent );
   void     DumpLengths(          LPDISPATCH pdispLengths,          HTREEITEM htParent );
   void     DumpLength(           LPDISPATCH pdispLength,           HTREEITEM htParent );
   void     DumpArrow(            LPDISPATCH pdispArrow,            HTREEITEM htParent );
   void     DumpSymbol(           LPDISPATCH pdispSymbol,           HTREEITEM htParent );
   void     DumpRect(             LPDISPATCH pdispRect,             HTREEITEM htParent );
   void     DumpEllipse(          LPDISPATCH pdispEllipse,          HTREEITEM htParent );
   void     DumpPoints(           LPDISPATCH pdispPoints,           HTREEITEM htParent );
   void     DumpPoint(            LPDISPATCH pdispPoint,            HTREEITEM htParent );

   CString  GetObjectType(  long lObjectType );
   CString  GetMeasureUnit( long lMeasureUnit );
   CString  GetLanguage(    long lLCID );

   long     GetObjectTypeFromDispatch( LPDISPATCH pdisp );

   //{{AFX_MSG(CPluginDialog)
   virtual BOOL OnInitDialog();
   afx_msg void OnUpdate();
   afx_msg void OnAbout();
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // PLUGINDIALOG_H__
